using System;
using System.Windows.Forms;
using Ventuz.OSC;					// namespace of the Ventuz.OSC.dll


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// This application demonstrates the remote control of Ventuz by OSC.
// This application can be found in the Toolbox Node Tutorial as well.
// This application was designed to control the Ventuz scene OSC_Remoting_1.vzs
// Its NOT meant as a general purpose remote client!
//
// Remember always to link to the latest version of the Ventuz.OSC.dll!
// The DLL can be found in the Ventuz installation folder.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


namespace OSC_Test
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Designer Varialbes

		private System.Windows.Forms.Label IP_Label;
		private System.Windows.Forms.Label Port_label;
		private System.Windows.Forms.Label Data_Label;
		private System.Windows.Forms.Label OSC_Label;
		private System.Windows.Forms.TextBox IP_TextBox;
		private System.Windows.Forms.NumericUpDown Port_UpDown;
		private System.Windows.Forms.TextBox OSC_TextBox;
		private System.Windows.Forms.ComboBox ComboBox_Type;
		private System.Windows.Forms.TextBox Data_TextBox_1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label Label_Element_1;
		private System.Windows.Forms.Label Label_Element_2;
		private System.Windows.Forms.Label Label_Element_3;
		private System.Windows.Forms.Label Label_Element_4;
		private System.Windows.Forms.TextBox Data_TextBox_2;
		private System.Windows.Forms.TextBox Data_TextBox_3;
		private System.Windows.Forms.TextBox Data_TextBox_4;
		private System.Windows.Forms.Button Button_Send;

		private System.ComponentModel.Container components = null;

		#endregion

		UdpWriter udpWriter = null;
		bool IP_or_Port_changed = false;

		public Form1()
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			// Initialize the UdpWriter with default parameters
			this.udpWriter = new UdpWriter(this.IP_TextBox.Text, (int)this.Port_UpDown.Value);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Button_Send = new System.Windows.Forms.Button();
			this.IP_TextBox = new System.Windows.Forms.TextBox();
			this.Port_UpDown = new System.Windows.Forms.NumericUpDown();
			this.IP_Label = new System.Windows.Forms.Label();
			this.Port_label = new System.Windows.Forms.Label();
			this.Data_Label = new System.Windows.Forms.Label();
			this.OSC_Label = new System.Windows.Forms.Label();
			this.OSC_TextBox = new System.Windows.Forms.TextBox();
			this.Label_Element_1 = new System.Windows.Forms.Label();
			this.Data_TextBox_1 = new System.Windows.Forms.TextBox();
			this.ComboBox_Type = new System.Windows.Forms.ComboBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.Data_TextBox_4 = new System.Windows.Forms.TextBox();
			this.Data_TextBox_3 = new System.Windows.Forms.TextBox();
			this.Label_Element_4 = new System.Windows.Forms.Label();
			this.Label_Element_3 = new System.Windows.Forms.Label();
			this.Label_Element_2 = new System.Windows.Forms.Label();
			this.Data_TextBox_2 = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.Port_UpDown)).BeginInit();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// Button_Send
			// 
			this.Button_Send.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Button_Send.Location = new System.Drawing.Point(96, 288);
			this.Button_Send.Name = "Button_Send";
			this.Button_Send.Size = new System.Drawing.Size(128, 32);
			this.Button_Send.TabIndex = 1;
			this.Button_Send.Text = "Send Data";
			this.Button_Send.Click += new System.EventHandler(this.Button_Send_Click);
			// 
			// IP_TextBox
			// 
			this.IP_TextBox.Location = new System.Drawing.Point(96, 32);
			this.IP_TextBox.Name = "IP_TextBox";
			this.IP_TextBox.Size = new System.Drawing.Size(112, 20);
			this.IP_TextBox.TabIndex = 2;
			this.IP_TextBox.Text = "127.0.0.1";
			this.IP_TextBox.TextChanged += new System.EventHandler(this.IP_TextBox_TextChanged);
			// 
			// Port_UpDown
			// 
			this.Port_UpDown.Location = new System.Drawing.Point(256, 32);
			this.Port_UpDown.Maximum = new System.Decimal(new int[] {
																		10000,
																		0,
																		0,
																		0});
			this.Port_UpDown.Minimum = new System.Decimal(new int[] {
																		1,
																		0,
																		0,
																		0});
			this.Port_UpDown.Name = "Port_UpDown";
			this.Port_UpDown.Size = new System.Drawing.Size(56, 20);
			this.Port_UpDown.TabIndex = 3;
			this.Port_UpDown.Value = new System.Decimal(new int[] {
																	  7000,
																	  0,
																	  0,
																	  0});
			this.Port_UpDown.ValueChanged += new System.EventHandler(this.Port_UpDown_ValueChanged);
			// 
			// IP_Label
			// 
			this.IP_Label.Location = new System.Drawing.Point(16, 32);
			this.IP_Label.Name = "IP_Label";
			this.IP_Label.Size = new System.Drawing.Size(64, 16);
			this.IP_Label.TabIndex = 4;
			this.IP_Label.Text = "IP-Adress:";
			// 
			// Port_label
			// 
			this.Port_label.Location = new System.Drawing.Point(216, 32);
			this.Port_label.Name = "Port_label";
			this.Port_label.Size = new System.Drawing.Size(32, 16);
			this.Port_label.TabIndex = 5;
			this.Port_label.Text = "Port:";
			// 
			// Data_Label
			// 
			this.Data_Label.Location = new System.Drawing.Point(16, 136);
			this.Data_Label.Name = "Data_Label";
			this.Data_Label.Size = new System.Drawing.Size(56, 16);
			this.Data_Label.TabIndex = 6;
			this.Data_Label.Text = "Datatype:";
			// 
			// OSC_Label
			// 
			this.OSC_Label.Location = new System.Drawing.Point(16, 64);
			this.OSC_Label.Name = "OSC_Label";
			this.OSC_Label.Size = new System.Drawing.Size(80, 16);
			this.OSC_Label.TabIndex = 7;
			this.OSC_Label.Text = "OSC-Adress:";
			// 
			// OSC_TextBox
			// 
			this.OSC_TextBox.Location = new System.Drawing.Point(96, 64);
			this.OSC_TextBox.Name = "OSC_TextBox";
			this.OSC_TextBox.Size = new System.Drawing.Size(112, 20);
			this.OSC_TextBox.TabIndex = 8;
			this.OSC_TextBox.Text = "/";
			// 
			// Label_Element_1
			// 
			this.Label_Element_1.Location = new System.Drawing.Point(16, 169);
			this.Label_Element_1.Name = "Label_Element_1";
			this.Label_Element_1.Size = new System.Drawing.Size(64, 16);
			this.Label_Element_1.TabIndex = 11;
			this.Label_Element_1.Text = "Element 1:";
			// 
			// Data_TextBox_1
			// 
			this.Data_TextBox_1.Location = new System.Drawing.Point(96, 168);
			this.Data_TextBox_1.Name = "Data_TextBox_1";
			this.Data_TextBox_1.Size = new System.Drawing.Size(112, 20);
			this.Data_TextBox_1.TabIndex = 14;
			this.Data_TextBox_1.Text = "0";
			// 
			// ComboBox_Type
			// 
			this.ComboBox_Type.Items.AddRange(new object[] {
															   "Int",
															   "Float",
															   "String"});
			this.ComboBox_Type.Location = new System.Drawing.Point(96, 136);
			this.ComboBox_Type.Name = "ComboBox_Type";
			this.ComboBox_Type.Size = new System.Drawing.Size(112, 21);
			this.ComboBox_Type.TabIndex = 15;
			this.ComboBox_Type.Text = "Int";
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(312, 88);
			this.groupBox1.TabIndex = 16;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Adress";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.Data_TextBox_4);
			this.groupBox2.Controls.Add(this.Data_TextBox_3);
			this.groupBox2.Controls.Add(this.Label_Element_4);
			this.groupBox2.Controls.Add(this.Label_Element_3);
			this.groupBox2.Controls.Add(this.Label_Element_2);
			this.groupBox2.Controls.Add(this.Data_TextBox_2);
			this.groupBox2.Location = new System.Drawing.Point(8, 112);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(312, 160);
			this.groupBox2.TabIndex = 17;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Data";
			// 
			// Data_TextBox_4
			// 
			this.Data_TextBox_4.Location = new System.Drawing.Point(88, 128);
			this.Data_TextBox_4.Name = "Data_TextBox_4";
			this.Data_TextBox_4.Size = new System.Drawing.Size(112, 20);
			this.Data_TextBox_4.TabIndex = 22;
			this.Data_TextBox_4.Text = "0";
			// 
			// Data_TextBox_3
			// 
			this.Data_TextBox_3.Location = new System.Drawing.Point(88, 104);
			this.Data_TextBox_3.Name = "Data_TextBox_3";
			this.Data_TextBox_3.Size = new System.Drawing.Size(112, 20);
			this.Data_TextBox_3.TabIndex = 21;
			this.Data_TextBox_3.Text = "0";
			// 
			// Label_Element_4
			// 
			this.Label_Element_4.Location = new System.Drawing.Point(8, 129);
			this.Label_Element_4.Name = "Label_Element_4";
			this.Label_Element_4.Size = new System.Drawing.Size(64, 16);
			this.Label_Element_4.TabIndex = 20;
			this.Label_Element_4.Text = "Element 4:";
			// 
			// Label_Element_3
			// 
			this.Label_Element_3.Location = new System.Drawing.Point(8, 105);
			this.Label_Element_3.Name = "Label_Element_3";
			this.Label_Element_3.Size = new System.Drawing.Size(64, 16);
			this.Label_Element_3.TabIndex = 19;
			this.Label_Element_3.Text = "Element 3:";
			// 
			// Label_Element_2
			// 
			this.Label_Element_2.Location = new System.Drawing.Point(8, 81);
			this.Label_Element_2.Name = "Label_Element_2";
			this.Label_Element_2.Size = new System.Drawing.Size(64, 16);
			this.Label_Element_2.TabIndex = 18;
			this.Label_Element_2.Text = "Element 2:";
			// 
			// Data_TextBox_2
			// 
			this.Data_TextBox_2.Location = new System.Drawing.Point(88, 80);
			this.Data_TextBox_2.Name = "Data_TextBox_2";
			this.Data_TextBox_2.Size = new System.Drawing.Size(112, 20);
			this.Data_TextBox_2.TabIndex = 18;
			this.Data_TextBox_2.Text = "0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 334);
			this.Controls.Add(this.ComboBox_Type);
			this.Controls.Add(this.Data_TextBox_1);
			this.Controls.Add(this.OSC_TextBox);
			this.Controls.Add(this.IP_TextBox);
			this.Controls.Add(this.Label_Element_1);
			this.Controls.Add(this.OSC_Label);
			this.Controls.Add(this.Data_Label);
			this.Controls.Add(this.Port_label);
			this.Controls.Add(this.Port_UpDown);
			this.Controls.Add(this.Button_Send);
			this.Controls.Add(this.IP_Label);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.groupBox2);
			this.Name = "Form1";
			this.Text = "OSC Control";
			((System.ComponentModel.ISupportInitialize)(this.Port_UpDown)).EndInit();
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void IP_TextBox_TextChanged(object sender, System.EventArgs e)
		{
			// IP adress changed!
			this.IP_or_Port_changed = true;
		}

		private void Port_UpDown_ValueChanged(object sender, System.EventArgs e)
		{
			// Port number changed!
			this.IP_or_Port_changed = true;
		}

		private void Button_Send_Click(object sender, System.EventArgs e)
		{
			bool udpWriterValid = false;

			if ( this.IP_or_Port_changed )
			{
				try
				{
					// Create new UdpWriter because IP or Port changed!
					this.udpWriter = new UdpWriter(this.IP_TextBox.Text, (int)this.Port_UpDown.Value);
					udpWriterValid = true;
				}
				catch (Exception ex)
				{
					// Failed to create new UdpWriter. Show Error message!
					MessageBox.Show(this, ex.Message, "Error");
				}
			}
			else
			{
				// nothing changed!
				udpWriterValid = true;
			}


			if ( udpWriterValid )
			{
				try
				{
					OscBundle bundle = CreateBundleFromDataElements();

					if ( bundle != null )
					{
						this.udpWriter.SendBundle(bundle);
						this.IP_or_Port_changed = false;
					}
				}
				catch (Exception ex)
				{
					// Failed to send bundle. Show Error message!
					MessageBox.Show(this, ex.Message, "Error");
					// Try to recreate next time!
					this.IP_or_Port_changed = true;
				}
			}
			
		}

		private OscBundle CreateBundleFromDataElements()
		{
			bool differentDataTypes = false;
			object[] elements = new object[4];

			if ( this.ComboBox_Type.Text == "Int" )
			{
				#region Create Int elements

				try
				{
					int elm;
					
					elm = Convert.ToInt32(this.Data_TextBox_1.Text);
					elements[0] = elm;

					elm = Convert.ToInt32(this.Data_TextBox_2.Text);
					elements[1] = elm;

					elm = Convert.ToInt32(this.Data_TextBox_3.Text);
					elements[2] = elm;

					elm = Convert.ToInt32(this.Data_TextBox_4.Text);
					elements[3] = elm;
				}
				catch
				{
					MessageBox.Show(this, "All Data Elements must be of type Int!", "Error");
					differentDataTypes = true;
				}

				#endregion
			}
			else if ( this.ComboBox_Type.Text == "Float" )
			{
				#region Create Float elements

				try
				{
					float elm;
					
					elm = Convert.ToSingle(this.Data_TextBox_1.Text);
					elements[0] = elm;

					elm = Convert.ToSingle(this.Data_TextBox_2.Text);
					elements[1] = elm;

					elm = Convert.ToSingle(this.Data_TextBox_3.Text);
					elements[2] = elm;

					elm = Convert.ToSingle(this.Data_TextBox_4.Text);
					elements[3] = elm;
				}
				catch
				{
					MessageBox.Show(this, "All Data Elements must be of type Float!", "Error");
					differentDataTypes = true;
				}

				#endregion
			}
			else
			{
				#region Create String elements

				elements[0] = new OscUnicodeString( this.Data_TextBox_1.Text );
				elements[1] = new OscUnicodeString( this.Data_TextBox_2.Text );
				elements[2] = new OscUnicodeString( this.Data_TextBox_3.Text );
				elements[3] = new OscUnicodeString( this.Data_TextBox_4.Text );

				#endregion
			}

			if ( ! differentDataTypes )
			{
				OscBundle bundle = new OscBundle();
				bundle.AddElement(new OscElement(this.OSC_TextBox.Text, elements));

				return bundle;
			}

			return null;
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
