using System;
using System.Windows.Forms;
using Ventuz.OSC;					// namespace of the Ventuz.OSC.dll


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// This application demonstrates the remote control of Ventuz by OSC.
// This application was designed to control the Ventuz scene OSC_Remoting_3.vzs
// Its NOT meant as a general purpose remote client!
//
// Remember always to link to the latest version of the Ventuz.OSC.dll!
// The DLL can be found in the Ventuz installation folder.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


namespace OSC_Test
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region Designer Variables

		private System.Windows.Forms.Label IP_Label;
		private System.Windows.Forms.Label Port_label;
		private System.Windows.Forms.TextBox IP_TextBox;
		private System.Windows.Forms.NumericUpDown Port_UpDown;
		private System.Windows.Forms.Button Button_Send;

		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.Label label_Image_1;
		private System.Windows.Forms.ComboBox comboBox_Images_1;
		private System.Windows.Forms.ComboBox comboBox_Images_2;
		private System.Windows.Forms.Label label_Image_2;
		private System.Windows.Forms.Label label_Value_1;
		private System.Windows.Forms.Label label_Value_2;
		private System.Windows.Forms.Label label_Value_3;
		private System.Windows.Forms.Label label_Value_4;
		private System.Windows.Forms.TextBox textBox_Value_1;
		private System.Windows.Forms.TextBox textBox_Value_2;
		private System.Windows.Forms.TextBox textBox_Value_3;
		private System.Windows.Forms.TextBox textBox_Value_4;
		private System.Windows.Forms.Label label_Title_1;
		private System.Windows.Forms.Label label_Title_2;
		private System.Windows.Forms.Label label_Title_3;
		private System.Windows.Forms.Label label_Title_4;
		private System.Windows.Forms.TextBox textBox_Title_1;
		private System.Windows.Forms.TextBox textBox_Title_2;
		private System.Windows.Forms.TextBox textBox_Title_3;
		private System.Windows.Forms.GroupBox groupBox_Adress;
		private System.Windows.Forms.GroupBox groupBox_Images;
		private System.Windows.Forms.GroupBox groupBox_Chart;
		private System.Windows.Forms.GroupBox groupBox_Crawl;
		private System.Windows.Forms.Label label_Text;
		private System.Windows.Forms.Label label_Status_1;
		private System.Windows.Forms.Label label_Status_2;
		private System.Windows.Forms.Button button_Restart;
		private System.Windows.Forms.Button button_Pause;
		private System.Windows.Forms.Button button_Continue;
		private System.Windows.Forms.Button button_Flip;
		private System.Windows.Forms.CheckBox checkBox_Autoupdate;
		private System.Windows.Forms.TextBox textBox_Title_4;
		private System.Windows.Forms.TextBox textBox_Crawltext;

		#endregion
		
		// UdpWriter for the OSC communication
		UdpWriter udpWriter = null;
		bool IP_or_Port_changed = false;

		// OSC Adresses:
		// neccessary to distinguish different OSC Nodes in a Ventuz scene
		private const string OSC_Flip = "/Flip"; 
		private const string OSC_Images = "/Images";
		private const string OSC_Crawltext = "/Crawltext";
		private const string OSC_CrawlRestart = "/CrawlRestart";
		private const string OSC_CrawlPause = "/CrawlPause";
		private const string OSC_CrawlContinue = "/CrawlContinue";
		private const string OSC_Chartvalues = "/Chartvalues";
		private const string OSC_Charttitles = "/Charttitles";

		#region Constructor

		public Form1()
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			this.comboBox_Images_1.SelectedIndex = 0;
			this.comboBox_Images_2.SelectedIndex = 1;

			// Initialize the UdpWriter for the OSC Messages with default parameters
			this.udpWriter = new UdpWriter(this.IP_TextBox.Text, (int)this.Port_UpDown.Value);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Button_Send = new System.Windows.Forms.Button();
			this.IP_TextBox = new System.Windows.Forms.TextBox();
			this.Port_UpDown = new System.Windows.Forms.NumericUpDown();
			this.IP_Label = new System.Windows.Forms.Label();
			this.Port_label = new System.Windows.Forms.Label();
			this.groupBox_Adress = new System.Windows.Forms.GroupBox();
			this.groupBox_Images = new System.Windows.Forms.GroupBox();
			this.label_Status_2 = new System.Windows.Forms.Label();
			this.label_Status_1 = new System.Windows.Forms.Label();
			this.button_Flip = new System.Windows.Forms.Button();
			this.comboBox_Images_2 = new System.Windows.Forms.ComboBox();
			this.label_Image_2 = new System.Windows.Forms.Label();
			this.comboBox_Images_1 = new System.Windows.Forms.ComboBox();
			this.label_Image_1 = new System.Windows.Forms.Label();
			this.groupBox_Chart = new System.Windows.Forms.GroupBox();
			this.textBox_Title_4 = new System.Windows.Forms.TextBox();
			this.textBox_Title_3 = new System.Windows.Forms.TextBox();
			this.textBox_Title_2 = new System.Windows.Forms.TextBox();
			this.textBox_Title_1 = new System.Windows.Forms.TextBox();
			this.label_Title_4 = new System.Windows.Forms.Label();
			this.label_Title_3 = new System.Windows.Forms.Label();
			this.label_Title_2 = new System.Windows.Forms.Label();
			this.label_Title_1 = new System.Windows.Forms.Label();
			this.textBox_Value_4 = new System.Windows.Forms.TextBox();
			this.textBox_Value_3 = new System.Windows.Forms.TextBox();
			this.textBox_Value_2 = new System.Windows.Forms.TextBox();
			this.textBox_Value_1 = new System.Windows.Forms.TextBox();
			this.label_Value_4 = new System.Windows.Forms.Label();
			this.label_Value_3 = new System.Windows.Forms.Label();
			this.label_Value_2 = new System.Windows.Forms.Label();
			this.label_Value_1 = new System.Windows.Forms.Label();
			this.groupBox_Crawl = new System.Windows.Forms.GroupBox();
			this.button_Continue = new System.Windows.Forms.Button();
			this.button_Pause = new System.Windows.Forms.Button();
			this.button_Restart = new System.Windows.Forms.Button();
			this.textBox_Crawltext = new System.Windows.Forms.TextBox();
			this.label_Text = new System.Windows.Forms.Label();
			this.checkBox_Autoupdate = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.Port_UpDown)).BeginInit();
			this.groupBox_Images.SuspendLayout();
			this.groupBox_Chart.SuspendLayout();
			this.groupBox_Crawl.SuspendLayout();
			this.SuspendLayout();
			// 
			// Button_Send
			// 
			this.Button_Send.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Button_Send.Location = new System.Drawing.Point(192, 504);
			this.Button_Send.Name = "Button_Send";
			this.Button_Send.Size = new System.Drawing.Size(128, 32);
			this.Button_Send.TabIndex = 1;
			this.Button_Send.Text = "Send Data";
			this.Button_Send.Click += new System.EventHandler(this.Button_Send_Click);
			// 
			// IP_TextBox
			// 
			this.IP_TextBox.Location = new System.Drawing.Point(96, 32);
			this.IP_TextBox.Name = "IP_TextBox";
			this.IP_TextBox.Size = new System.Drawing.Size(112, 20);
			this.IP_TextBox.TabIndex = 2;
			this.IP_TextBox.Text = "127.0.0.1";
			this.IP_TextBox.TextChanged += new System.EventHandler(this.IP_TextBox_TextChanged);
			// 
			// Port_UpDown
			// 
			this.Port_UpDown.Location = new System.Drawing.Point(256, 32);
			this.Port_UpDown.Maximum = new System.Decimal(new int[] {
																		10000,
																		0,
																		0,
																		0});
			this.Port_UpDown.Minimum = new System.Decimal(new int[] {
																		1,
																		0,
																		0,
																		0});
			this.Port_UpDown.Name = "Port_UpDown";
			this.Port_UpDown.Size = new System.Drawing.Size(56, 20);
			this.Port_UpDown.TabIndex = 3;
			this.Port_UpDown.Value = new System.Decimal(new int[] {
																	  7000,
																	  0,
																	  0,
																	  0});
			this.Port_UpDown.ValueChanged += new System.EventHandler(this.Port_UpDown_ValueChanged);
			// 
			// IP_Label
			// 
			this.IP_Label.Location = new System.Drawing.Point(16, 32);
			this.IP_Label.Name = "IP_Label";
			this.IP_Label.Size = new System.Drawing.Size(64, 16);
			this.IP_Label.TabIndex = 4;
			this.IP_Label.Text = "IP-Adress:";
			// 
			// Port_label
			// 
			this.Port_label.Location = new System.Drawing.Point(216, 32);
			this.Port_label.Name = "Port_label";
			this.Port_label.Size = new System.Drawing.Size(32, 16);
			this.Port_label.TabIndex = 5;
			this.Port_label.Text = "Port:";
			// 
			// groupBox_Adress
			// 
			this.groupBox_Adress.Location = new System.Drawing.Point(8, 8);
			this.groupBox_Adress.Name = "groupBox_Adress";
			this.groupBox_Adress.Size = new System.Drawing.Size(312, 56);
			this.groupBox_Adress.TabIndex = 16;
			this.groupBox_Adress.TabStop = false;
			this.groupBox_Adress.Text = "Adress";
			// 
			// groupBox_Images
			// 
			this.groupBox_Images.Controls.Add(this.label_Status_2);
			this.groupBox_Images.Controls.Add(this.label_Status_1);
			this.groupBox_Images.Controls.Add(this.button_Flip);
			this.groupBox_Images.Controls.Add(this.comboBox_Images_2);
			this.groupBox_Images.Controls.Add(this.label_Image_2);
			this.groupBox_Images.Controls.Add(this.comboBox_Images_1);
			this.groupBox_Images.Controls.Add(this.label_Image_1);
			this.groupBox_Images.Location = new System.Drawing.Point(8, 80);
			this.groupBox_Images.Name = "groupBox_Images";
			this.groupBox_Images.Size = new System.Drawing.Size(312, 120);
			this.groupBox_Images.TabIndex = 17;
			this.groupBox_Images.TabStop = false;
			this.groupBox_Images.Text = "Images";
			// 
			// label_Status_2
			// 
			this.label_Status_2.Location = new System.Drawing.Point(224, 64);
			this.label_Status_2.Name = "label_Status_2";
			this.label_Status_2.Size = new System.Drawing.Size(80, 16);
			this.label_Status_2.TabIndex = 7;
			// 
			// label_Status_1
			// 
			this.label_Status_1.Location = new System.Drawing.Point(224, 32);
			this.label_Status_1.Name = "label_Status_1";
			this.label_Status_1.Size = new System.Drawing.Size(80, 16);
			this.label_Status_1.TabIndex = 6;
			// 
			// button_Flip
			// 
			this.button_Flip.Location = new System.Drawing.Point(224, 88);
			this.button_Flip.Name = "button_Flip";
			this.button_Flip.Size = new System.Drawing.Size(80, 24);
			this.button_Flip.TabIndex = 5;
			this.button_Flip.Text = "Flip";
			this.button_Flip.Click += new System.EventHandler(this.button_Flip_Click);
			// 
			// comboBox_Images_2
			// 
			this.comboBox_Images_2.Items.AddRange(new object[] {
																   "peppers.jpg",
																   "avocado.jpg",
																   "tomatos.jpg",
																   "banana.jpg"});
			this.comboBox_Images_2.Location = new System.Drawing.Point(72, 62);
			this.comboBox_Images_2.Name = "comboBox_Images_2";
			this.comboBox_Images_2.Size = new System.Drawing.Size(128, 21);
			this.comboBox_Images_2.TabIndex = 4;
			this.comboBox_Images_2.Text = "comboBox1";
			this.comboBox_Images_2.SelectedIndexChanged += new System.EventHandler(this.comboBox_Images_2_SelectedIndexChanged);
			// 
			// label_Image_2
			// 
			this.label_Image_2.Location = new System.Drawing.Point(16, 64);
			this.label_Image_2.Name = "label_Image_2";
			this.label_Image_2.Size = new System.Drawing.Size(48, 16);
			this.label_Image_2.TabIndex = 3;
			this.label_Image_2.Text = "Image 2:";
			// 
			// comboBox_Images_1
			// 
			this.comboBox_Images_1.Items.AddRange(new object[] {
																   "peppers.jpg",
																   "avocado.jpg",
																   "tomatos.jpg",
																   "banana.jpg"});
			this.comboBox_Images_1.Location = new System.Drawing.Point(72, 28);
			this.comboBox_Images_1.Name = "comboBox_Images_1";
			this.comboBox_Images_1.Size = new System.Drawing.Size(128, 21);
			this.comboBox_Images_1.TabIndex = 2;
			this.comboBox_Images_1.Text = "comboBox1";
			this.comboBox_Images_1.SelectedIndexChanged += new System.EventHandler(this.comboBox_Images_1_SelectedIndexChanged);
			// 
			// label_Image_1
			// 
			this.label_Image_1.Location = new System.Drawing.Point(16, 30);
			this.label_Image_1.Name = "label_Image_1";
			this.label_Image_1.Size = new System.Drawing.Size(48, 16);
			this.label_Image_1.TabIndex = 0;
			this.label_Image_1.Text = "Image 1:";
			// 
			// groupBox_Chart
			// 
			this.groupBox_Chart.Controls.Add(this.textBox_Title_4);
			this.groupBox_Chart.Controls.Add(this.textBox_Title_3);
			this.groupBox_Chart.Controls.Add(this.textBox_Title_2);
			this.groupBox_Chart.Controls.Add(this.textBox_Title_1);
			this.groupBox_Chart.Controls.Add(this.label_Title_4);
			this.groupBox_Chart.Controls.Add(this.label_Title_3);
			this.groupBox_Chart.Controls.Add(this.label_Title_2);
			this.groupBox_Chart.Controls.Add(this.label_Title_1);
			this.groupBox_Chart.Controls.Add(this.textBox_Value_4);
			this.groupBox_Chart.Controls.Add(this.textBox_Value_3);
			this.groupBox_Chart.Controls.Add(this.textBox_Value_2);
			this.groupBox_Chart.Controls.Add(this.textBox_Value_1);
			this.groupBox_Chart.Controls.Add(this.label_Value_4);
			this.groupBox_Chart.Controls.Add(this.label_Value_3);
			this.groupBox_Chart.Controls.Add(this.label_Value_2);
			this.groupBox_Chart.Controls.Add(this.label_Value_1);
			this.groupBox_Chart.Location = new System.Drawing.Point(8, 216);
			this.groupBox_Chart.Name = "groupBox_Chart";
			this.groupBox_Chart.Size = new System.Drawing.Size(312, 160);
			this.groupBox_Chart.TabIndex = 18;
			this.groupBox_Chart.TabStop = false;
			this.groupBox_Chart.Text = "Chart";
			// 
			// textBox_Title_4
			// 
			this.textBox_Title_4.Location = new System.Drawing.Point(176, 126);
			this.textBox_Title_4.Name = "textBox_Title_4";
			this.textBox_Title_4.Size = new System.Drawing.Size(126, 20);
			this.textBox_Title_4.TabIndex = 15;
			this.textBox_Title_4.Text = "Peppers";
			this.textBox_Title_4.TextChanged += new System.EventHandler(this.textBox_Title_4_TextChanged);
			// 
			// textBox_Title_3
			// 
			this.textBox_Title_3.Location = new System.Drawing.Point(176, 94);
			this.textBox_Title_3.Name = "textBox_Title_3";
			this.textBox_Title_3.Size = new System.Drawing.Size(126, 20);
			this.textBox_Title_3.TabIndex = 14;
			this.textBox_Title_3.Text = "Tomatos";
			this.textBox_Title_3.TextChanged += new System.EventHandler(this.textBox_Title_3_TextChanged);
			// 
			// textBox_Title_2
			// 
			this.textBox_Title_2.Location = new System.Drawing.Point(176, 62);
			this.textBox_Title_2.Name = "textBox_Title_2";
			this.textBox_Title_2.Size = new System.Drawing.Size(126, 20);
			this.textBox_Title_2.TabIndex = 13;
			this.textBox_Title_2.Text = "Bananas";
			this.textBox_Title_2.TextChanged += new System.EventHandler(this.textBox_Title_2_TextChanged);
			// 
			// textBox_Title_1
			// 
			this.textBox_Title_1.Location = new System.Drawing.Point(176, 30);
			this.textBox_Title_1.Name = "textBox_Title_1";
			this.textBox_Title_1.Size = new System.Drawing.Size(126, 20);
			this.textBox_Title_1.TabIndex = 12;
			this.textBox_Title_1.Text = "Avocados";
			this.textBox_Title_1.TextChanged += new System.EventHandler(this.textBox_Title_1_TextChanged);
			// 
			// label_Title_4
			// 
			this.label_Title_4.Location = new System.Drawing.Point(132, 128);
			this.label_Title_4.Name = "label_Title_4";
			this.label_Title_4.Size = new System.Drawing.Size(44, 16);
			this.label_Title_4.TabIndex = 11;
			this.label_Title_4.Text = "Title 4:";
			// 
			// label_Title_3
			// 
			this.label_Title_3.Location = new System.Drawing.Point(132, 96);
			this.label_Title_3.Name = "label_Title_3";
			this.label_Title_3.Size = new System.Drawing.Size(44, 16);
			this.label_Title_3.TabIndex = 10;
			this.label_Title_3.Text = "Title 3:";
			// 
			// label_Title_2
			// 
			this.label_Title_2.Location = new System.Drawing.Point(132, 64);
			this.label_Title_2.Name = "label_Title_2";
			this.label_Title_2.Size = new System.Drawing.Size(44, 16);
			this.label_Title_2.TabIndex = 9;
			this.label_Title_2.Text = "Title 2:";
			// 
			// label_Title_1
			// 
			this.label_Title_1.Location = new System.Drawing.Point(132, 32);
			this.label_Title_1.Name = "label_Title_1";
			this.label_Title_1.Size = new System.Drawing.Size(44, 16);
			this.label_Title_1.TabIndex = 8;
			this.label_Title_1.Text = "Title 1:";
			// 
			// textBox_Value_4
			// 
			this.textBox_Value_4.Location = new System.Drawing.Point(72, 126);
			this.textBox_Value_4.Name = "textBox_Value_4";
			this.textBox_Value_4.Size = new System.Drawing.Size(48, 20);
			this.textBox_Value_4.TabIndex = 7;
			this.textBox_Value_4.Text = "1";
			this.textBox_Value_4.TextChanged += new System.EventHandler(this.textBox_Value_4_TextChanged);
			// 
			// textBox_Value_3
			// 
			this.textBox_Value_3.Location = new System.Drawing.Point(72, 94);
			this.textBox_Value_3.Name = "textBox_Value_3";
			this.textBox_Value_3.Size = new System.Drawing.Size(48, 20);
			this.textBox_Value_3.TabIndex = 6;
			this.textBox_Value_3.Text = "1";
			this.textBox_Value_3.TextChanged += new System.EventHandler(this.textBox_Value_3_TextChanged);
			// 
			// textBox_Value_2
			// 
			this.textBox_Value_2.Location = new System.Drawing.Point(72, 62);
			this.textBox_Value_2.Name = "textBox_Value_2";
			this.textBox_Value_2.Size = new System.Drawing.Size(48, 20);
			this.textBox_Value_2.TabIndex = 5;
			this.textBox_Value_2.Text = "1";
			this.textBox_Value_2.TextChanged += new System.EventHandler(this.textBox_Value_2_TextChanged);
			// 
			// textBox_Value_1
			// 
			this.textBox_Value_1.Location = new System.Drawing.Point(72, 30);
			this.textBox_Value_1.Name = "textBox_Value_1";
			this.textBox_Value_1.Size = new System.Drawing.Size(48, 20);
			this.textBox_Value_1.TabIndex = 4;
			this.textBox_Value_1.Text = "1";
			this.textBox_Value_1.TextChanged += new System.EventHandler(this.textBox_Value_1_TextChanged);
			// 
			// label_Value_4
			// 
			this.label_Value_4.Location = new System.Drawing.Point(16, 128);
			this.label_Value_4.Name = "label_Value_4";
			this.label_Value_4.Size = new System.Drawing.Size(48, 16);
			this.label_Value_4.TabIndex = 3;
			this.label_Value_4.Text = "Value 4:";
			// 
			// label_Value_3
			// 
			this.label_Value_3.Location = new System.Drawing.Point(16, 96);
			this.label_Value_3.Name = "label_Value_3";
			this.label_Value_3.Size = new System.Drawing.Size(48, 16);
			this.label_Value_3.TabIndex = 2;
			this.label_Value_3.Text = "Value 3:";
			// 
			// label_Value_2
			// 
			this.label_Value_2.Location = new System.Drawing.Point(16, 64);
			this.label_Value_2.Name = "label_Value_2";
			this.label_Value_2.Size = new System.Drawing.Size(48, 16);
			this.label_Value_2.TabIndex = 1;
			this.label_Value_2.Text = "Value 2:";
			// 
			// label_Value_1
			// 
			this.label_Value_1.Location = new System.Drawing.Point(16, 32);
			this.label_Value_1.Name = "label_Value_1";
			this.label_Value_1.Size = new System.Drawing.Size(48, 16);
			this.label_Value_1.TabIndex = 0;
			this.label_Value_1.Text = "Value 1:";
			// 
			// groupBox_Crawl
			// 
			this.groupBox_Crawl.Controls.Add(this.button_Continue);
			this.groupBox_Crawl.Controls.Add(this.button_Pause);
			this.groupBox_Crawl.Controls.Add(this.button_Restart);
			this.groupBox_Crawl.Controls.Add(this.textBox_Crawltext);
			this.groupBox_Crawl.Controls.Add(this.label_Text);
			this.groupBox_Crawl.Location = new System.Drawing.Point(8, 392);
			this.groupBox_Crawl.Name = "groupBox_Crawl";
			this.groupBox_Crawl.Size = new System.Drawing.Size(312, 96);
			this.groupBox_Crawl.TabIndex = 19;
			this.groupBox_Crawl.TabStop = false;
			this.groupBox_Crawl.Text = "Crawl";
			// 
			// button_Continue
			// 
			this.button_Continue.Location = new System.Drawing.Point(240, 56);
			this.button_Continue.Name = "button_Continue";
			this.button_Continue.Size = new System.Drawing.Size(64, 24);
			this.button_Continue.TabIndex = 4;
			this.button_Continue.Text = "Continue";
			this.button_Continue.Click += new System.EventHandler(this.button_Continue_Click);
			// 
			// button_Pause
			// 
			this.button_Pause.Location = new System.Drawing.Point(128, 56);
			this.button_Pause.Name = "button_Pause";
			this.button_Pause.Size = new System.Drawing.Size(64, 24);
			this.button_Pause.TabIndex = 3;
			this.button_Pause.Text = "Pause";
			this.button_Pause.Click += new System.EventHandler(this.button_Pause_Click);
			// 
			// button_Restart
			// 
			this.button_Restart.Location = new System.Drawing.Point(16, 56);
			this.button_Restart.Name = "button_Restart";
			this.button_Restart.Size = new System.Drawing.Size(64, 24);
			this.button_Restart.TabIndex = 2;
			this.button_Restart.Text = "Restart";
			this.button_Restart.Click += new System.EventHandler(this.button_Restart_Click);
			// 
			// textBox_Crawltext
			// 
			this.textBox_Crawltext.Location = new System.Drawing.Point(72, 22);
			this.textBox_Crawltext.Name = "textBox_Crawltext";
			this.textBox_Crawltext.Size = new System.Drawing.Size(232, 20);
			this.textBox_Crawltext.TabIndex = 1;
			this.textBox_Crawltext.Text = "Text for the Crawl...";
			this.textBox_Crawltext.TextChanged += new System.EventHandler(this.textBox_Crawltext_TextChanged);
			// 
			// label_Text
			// 
			this.label_Text.Location = new System.Drawing.Point(16, 24);
			this.label_Text.Name = "label_Text";
			this.label_Text.Size = new System.Drawing.Size(32, 16);
			this.label_Text.TabIndex = 0;
			this.label_Text.Text = "Text:";
			// 
			// checkBox_Autoupdate
			// 
			this.checkBox_Autoupdate.Location = new System.Drawing.Point(8, 512);
			this.checkBox_Autoupdate.Name = "checkBox_Autoupdate";
			this.checkBox_Autoupdate.Size = new System.Drawing.Size(128, 16);
			this.checkBox_Autoupdate.TabIndex = 20;
			this.checkBox_Autoupdate.Text = "Auto-Update Data";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 550);
			this.Controls.Add(this.checkBox_Autoupdate);
			this.Controls.Add(this.groupBox_Crawl);
			this.Controls.Add(this.groupBox_Chart);
			this.Controls.Add(this.IP_TextBox);
			this.Controls.Add(this.Port_label);
			this.Controls.Add(this.Port_UpDown);
			this.Controls.Add(this.Button_Send);
			this.Controls.Add(this.IP_Label);
			this.Controls.Add(this.groupBox_Adress);
			this.Controls.Add(this.groupBox_Images);
			this.MaximumSize = new System.Drawing.Size(336, 584);
			this.MinimumSize = new System.Drawing.Size(336, 584);
			this.Name = "Form1";
			this.Text = "OSC Remoting 3";
			((System.ComponentModel.ISupportInitialize)(this.Port_UpDown)).EndInit();
			this.groupBox_Images.ResumeLayout(false);
			this.groupBox_Chart.ResumeLayout(false);
			this.groupBox_Crawl.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		private void SendOSCBundle(OscBundle bundle)
		{
			bool udpWriterValid = false;

			// Check IP adress and Port number
			if ( this.IP_or_Port_changed )
			{
				try
				{
					// Create new UdpWriter because IP or Port changed!
					this.udpWriter = new UdpWriter(this.IP_TextBox.Text, (int)this.Port_UpDown.Value);
					udpWriterValid = true;
				}
				catch (Exception ex)
				{
					// Failed to create new UdpWriter. Show Error message!
					MessageBox.Show(this, ex.Message, "Error");
				}
			}
			else
			{
				// nothing changed!
				udpWriterValid = true;
			}

			// Send OSC Message
			if ( udpWriterValid )
			{
				try
				{
					if ( bundle != null )
					{
						// send OSC data
						this.udpWriter.SendBundle(bundle);
						this.IP_or_Port_changed = false;
					}
				}
				catch (Exception ex)
				{
					// Failed to send bundle. Show Error message!
					MessageBox.Show(this, ex.Message, "Error");
					// Try to recreate next time!
					this.IP_or_Port_changed = true;
				}
			}
		}

		private OscBundle CreateBundleFromDataElements()
		{
			OscBundle bundle = new OscBundle();

			// Collect OSC Elements for the Bundle
			bundle.AddElement(this.GetImageElements());
			bundle.AddElement(this.GetChartValueElements());
			bundle.AddElement(this.GetChartTitleElements());
			bundle.AddElement(this.GetCrawltextElements());

			// bundle is ready!
			return bundle;
		}

		private OscElement GetImageElements()
		{
			object[] elements = new object[2];

			elements[0] = this.comboBox_Images_1.Text;
			elements[1] = this.comboBox_Images_2.Text;

			return new OscElement(OSC_Images, elements);
		}

		private OscElement GetChartValueElements()
		{
			object[] elements = new object[4];

			try
			{
				elements[0] = Convert.ToSingle(this.textBox_Value_1.Text);
				elements[1] = Convert.ToSingle(this.textBox_Value_2.Text);
				elements[2] = Convert.ToSingle(this.textBox_Value_3.Text);
				elements[3] = Convert.ToSingle(this.textBox_Value_4.Text);

			}
			catch
			{
				MessageBox.Show(this, "All Chart Values must be of type Float!", "Error");
				return null;
			}

			return new OscElement(OSC_Chartvalues, elements);
		}

		private OscElement GetChartTitleElements()
		{
			object[] elements = new object[4];

            // enable arabic etc. by using OscUnicodeString
			elements[0] = new OscUnicodeString(this.textBox_Title_1.Text);
			elements[1] = new OscUnicodeString(this.textBox_Title_2.Text);
			elements[2] = new OscUnicodeString(this.textBox_Title_3.Text);
			elements[3] = new OscUnicodeString(this.textBox_Title_4.Text);

			return new OscElement(OSC_Charttitles, elements);
		}

		private OscElement GetCrawltextElements()
		{
			object elements = this.textBox_Crawltext.Text;

			return new OscElement(OSC_Crawltext, elements);
		}

		private void AutoUpdateImageData()
		{
			OscBundle bundle = new OscBundle();
			bundle.AddElement(GetImageElements());

			SendOSCBundle(bundle);
		}

		private void AutoUpdateChartData()
		{
			OscBundle bundle = new OscBundle();
			bundle.AddElement(GetChartValueElements());
			bundle.AddElement(GetChartTitleElements());

			SendOSCBundle(bundle);
		}

		private void AutoUpdateCrawlData()
		{
			OscBundle bundle = new OscBundle();
			bundle.AddElement(GetCrawltextElements());

			SendOSCBundle(bundle);
		}

		private void IP_TextBox_TextChanged(object sender, System.EventArgs e)
		{
			// IP adress changed!
			this.IP_or_Port_changed = true;
		}

		private void Port_UpDown_ValueChanged(object sender, System.EventArgs e)
		{
			// Port number changed!
			this.IP_or_Port_changed = true;
		}

		#region Button Click Event Handling

		private void Button_Send_Click(object sender, System.EventArgs e)
		{
			OscBundle bundle = CreateBundleFromDataElements();
			SendOSCBundle(bundle);
		}

		private void button_Flip_Click(object sender, System.EventArgs e)
		{
			OscBundle bundle = new OscBundle();
			OscElement element = new OscElement(OSC_Flip, 1);
			bundle.AddElement(element);

			SendOSCBundle(bundle);
		}

		private void button_Restart_Click(object sender, System.EventArgs e)
		{
			OscBundle bundle = new OscBundle();
			OscElement element = new OscElement(OSC_CrawlRestart, 1);
			bundle.AddElement(element);

			SendOSCBundle(bundle);
		}

		private void button_Pause_Click(object sender, System.EventArgs e)
		{
			OscBundle bundle = new OscBundle();
			OscElement element = new OscElement(OSC_CrawlPause, 1);
			bundle.AddElement(element);

			SendOSCBundle(bundle);
		}

		private void button_Continue_Click(object sender, System.EventArgs e)
		{
			OscBundle bundle = new OscBundle();
			OscElement element = new OscElement(OSC_CrawlContinue, 1);
			bundle.AddElement(element);

			SendOSCBundle(bundle);
		}

		#endregion

		#region Data Change Event Handling

		private void comboBox_Images_1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateImageData();
		}

		private void comboBox_Images_2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateImageData();
		}

		private void textBox_Value_1_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Value_2_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Value_3_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Value_4_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Title_1_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Title_2_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Title_3_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Title_4_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateChartData();
		}

		private void textBox_Crawltext_TextChanged(object sender, System.EventArgs e)
		{
			if ( this.checkBox_Autoupdate.Checked )
				AutoUpdateCrawlData();
		}

		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
